=== hyprctl/Makefile ===
all:
	$(CXX) $(CXXFLAGS) -std=c++2b ./main.cpp -o ./hyprctl
clean:
	rm ./hyprctl
