=== debian/control ===
Source: hyprland
Section: x11
Priority: optional
Maintainer: Alan M Varghese (NyxTrail) <alan@digistorm.in>
Build-Depends:
 chrpath,
 cmake,
 cpio,
 debhelper-compat (= 13),
 hwdata,
 hyprland-protocols (>= 0.2+20240505),
 hyprwayland-scanner (>= 0.3.10),
 libcairo-dev,
 libdrm-dev,
 libxkbcommon-dev,
 libegl-dev,
 libegl1-mesa-dev,
 libgles-dev,
 libhyprlang-dev (>= 0.3.2),
 libhyprcursor-dev (>= 0.1.7),
 libhyprutils-dev (>= 0.1.5),
 libinput-dev,
 libpango1.0-dev,
 libpixman-1-dev,
 libseat-dev,
 libtomlplusplus-dev,
 libudev-dev,
 libudis86-dev (>= 0+20221013),
 libwayland-dev,
 libwlroots-0.18-dev,
 libxcb-errors-dev,
 libxcb-util-dev,
 meson,
 ninja-build,
 pkgconf,
 wayland-protocols,
 xwayland
Standards-Version: 4.7.0
Homepage: https://hyprland.org
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/NyxTrail/hyprland.git
Vcs-Browser: https://salsa.debian.org/NyxTrail/hyprland

Package: hyprland
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
 polkitd, binutils, libgl1-mesa-dri
Recommends: xwayland
Description: Dynamic tiling Wayland compositor
 Hyprland is a dynamic tiling Wayland compositor based on
 wlroots that doesn't sacrifice on its looks. It provides
 the latest Wayland features, is highly customizable, has
 all the eyecandy, the most powerful plugins, easy IPC,
 much more QoL stuff than other wlr-based compositors and
 more...

Package: hyprland-backgrounds
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: hyprland
Description: Set of backgrounds packaged with the hyprland Wayland compositor
 Hyprland is a dynamic tiling Wayland compositor based on
 wlroots that doesn't sacrifice on its looks. It provides
 the latest Wayland features, is highly customizable, has
 all the eyecandy, the most powerful plugins, easy IPC,
 much more QoL stuff than other wlr-based compositors and
 more...
 .
 This package contains the backgrounds included with Hyprland.

Package: hyprland-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}
Description: Development files for Hyprland
 Hyprland is a dynamic tiling Wayland compositor based on
 wlroots that doesn't sacrifice on its looks. It provides
 the latest Wayland features, is highly customizable, has
 all the eyecandy, the most powerful plugins, easy IPC,
 much more QoL stuff than other wlr-based compositors and
 more...
 .
 This package contains header files for developing plugins
 for Hyprland.
