=== debian/changelog ===
hyprland (0.51.1+ds-1) unstable; urgency=medium

  * Salvage package (Closes: #1118076):
    - Change maintainer to Hyprland team
    - Update Vcs-* fields to point to Hyprland team
  * New upstream version 0.51.1+ds
  * Backport patch to fix chrome crash when moved between monitors
  * Backport patch to fix monitors getting stuck off

 -- Chow Loong Jin <hyperair@debian.org>  Wed, 05 Nov 2025 17:12:46 +0800

hyprland (0.51.0+ds-0.1) UNRELEASED; urgency=medium

  * Non-maintainer upload
  * New upstream version 0.51.0+ds
  * Refresh patches

 -- Chow Loong Jin <hyperair@debian.org>  Thu, 11 Sep 2025 12:45:14 +0800

hyprland (0.50.1+ds-0.1) UNRELEASED; urgency=medium

  * Non-maintainer upload
  [ alan (NyxTrail) ]
  * Update build dep:
    - libaquamarine to v0.8.0
    - hyprutils to v0.6.0

  [ Chow Loong Jin ]
  * New upstream version 0.50.1+ds (Closes: #1087480)
    - Also fixes chrome drag-n-drop issues (Closes: #1106539)
  * Update build-deps
    - Drop libwlroots-dev build-dep
    - Update hypr package versions
    - Add new xcb packages
    - Add libgbm-dev
  * Refresh patches
  * Directly use cmake build system
  * Import patches from hyprland-ppa.
    These fix some FTBFS around using an older g++, and also allow hyprpm to
    work without needing a clone.
    Thanks to Constantin Piber <cp.piber@gmail.com>
  * Build-dep on xxd.
    Needed for the #embed workaround patch
  * d/copyright: Remove FSF address

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 25 Aug 2025 21:00:59 +0800

hyprland (0.48.1+ds-1) unstable; urgency=medium

  [ alan (NyxTrail) ]
  * New upstream version 0.48.1

 -- Alan M Varghese (NyxTrail) <alan@digistorm.in>  Mon, 07 Apr 2025 14:16:34 +0000

hyprland (0.47.2+ds-1) unstable; urgency=medium

  * New upstream version 0.47.2 

 -- Alan M Varghese (NyxTrail) <alan@digistorm.in>  Sun, 09 Mar 2025 05:54:20 +0000

hyprland (0.44.1+ds-1) unstable; urgency=medium

  * New upstream version 0.44.1

 -- Alan M Varghese (NyxTrail) <alan@digistorm.in>  Fri, 11 Oct 2024 13:44:58 +0000
