=== debian/control ===
--- 
+++ 
@@ -1,8 +1,13 @@
 Source: hyprland
 Section: x11
 Priority: optional
-Maintainer: Alan M Varghese (NyxTrail) <alan@digistorm.in>
+Maintainer: Debian Hyprland Maintainers <team+hyprland@tracker.debian.org>
+Uploaders:
+ Alan M Varghese (NyxTrail) <alan@digistorm.in>,
+ Carl Keinath <carl.keinath@gmail.com>,
+ Chow Loong Jin <hyperair@debian.org>
 Build-Depends:
+ libaquamarine-dev (>= 0.9.0),
  chrpath,
  cmake,
  cpio,
@@ -15,31 +20,41 @@
  libxkbcommon-dev,
  libegl-dev,
  libegl1-mesa-dev,
+ libgbm-dev,
+ libglaze-dev,
  libgles-dev,
  libhyprlang-dev (>= 0.3.2),
  libhyprcursor-dev (>= 0.1.7),
- libhyprutils-dev (>= 0.1.5),
+ libhyprutils-dev (>= 0.8.1),
+ libhyprgraphics-dev (>= 0.1.3),
  libinput-dev,
  libpango1.0-dev,
  libpixman-1-dev,
+ libre2-dev,
  libseat-dev,
  libtomlplusplus-dev,
  libudev-dev,
  libudis86-dev (>= 0+20221013),
  libwayland-dev,
- libwlroots-0.18-dev,
+ libxcb1-dev,
+ libxcb-render0-dev,
+ libxcb-xfixes0-dev,
+ libxcb-icccm4-dev,
+ libxcb-composite0-dev,
+ libxcb-res0-dev,
  libxcb-errors-dev,
- libxcb-util-dev,
  meson,
  ninja-build,
  pkgconf,
  wayland-protocols,
- xwayland
+ libxcursor-dev,
+ xwayland,
+ xxd
 Standards-Version: 4.7.0
 Homepage: https://hyprland.org
 Rules-Requires-Root: no
-Vcs-Git: https://salsa.debian.org/NyxTrail/hyprland.git
-Vcs-Browser: https://salsa.debian.org/NyxTrail/hyprland
+Vcs-Git: https://salsa.debian.org/hyprland-team/hyprland.git
+Vcs-Browser: https://salsa.debian.org/hyprland-team/hyprland
 
 Package: hyprland
 Architecture: any
